<template>
    <div
        v-if="pageReady"
        class="w-full"
    >
        <auto-form
            ref="form"
            :default-data="model"
            :hidden-data="{
                account_code: account
            }"
            :fields="formFields"
        />
        <auto-button
            block
            :disabled="form && form.busy ? form.busy : false"
            :busy="form && form.busy ? form.busy : false"
            @click="submitForm"
        >
            {{ $t('submit') }}
        </auto-button>
    </div>
</template>

<script setup>
import {ref, computed, onMounted, nextTick} from "vue";
import {useI18n} from "vue-i18n";
import AutoForm from "~/components/auto-form.vue";
import AutoButton from "~/components/button/auto-button.vue";

const props = defineProps({
    account: {
        required: true,
        type: String,
    }
});

const emit = defineEmits(['close']);

const i18n = useI18n();

const selectForAccounts = {
    'DEPOSIT': [
        {text: i18n.t('transfer_to_assured_account'), value: 'transfer_to_assured_account'},
        {text: i18n.t('transfer_to_structured_account'), value: 'transfer_to_structured_account'},
        {text: i18n.t('debit'), value: 'debit'},
        {text: i18n.t('credit'), value: 'credit'},
    ],
    'ASSURED': [
        {text: i18n.t('transfer_to_structured_account'), value: 'transfer_to_structured_account'},
        {text: i18n.t('transfer_to_opex_account'), value: 'transfer_to_opex_account'},
        {text: i18n.t('debit'), value: 'debit'},
        {text: i18n.t('credit'), value: 'credit'},
    ],
    'STRUCTURED': [
        {text: i18n.t('transfer_to_assured_account'), value: 'transfer_to_assured_account'},
        {text: i18n.t('transfer_to_opex_account'), value: 'transfer_to_opex_account'},
        {text: i18n.t('debit'), value: 'debit'},
        {text: i18n.t('credit'), value: 'credit'},
    ],
    'OPEX': [
        {text: i18n.t('debit'), value: 'debit'},
        {text: i18n.t('credit'), value: 'credit'},
    ],
    'PL': [
        {text: i18n.t('debit'), value: 'debit'},
        {text: i18n.t('credit'), value: 'credit'},
    ],
    'RESERVED': [
        {text: i18n.t('debit'), value: 'debit'},
        {text: i18n.t('credit'), value: 'credit'},
    ],
};

const actionSelects = computed(() => {
    return selectForAccounts[props.account] || [];
});

const pageReady = ref(false);
const model = ref({});
const form = ref();
const formFields = computed(() => {
    return [
        {
            type: 'text',
            name: 'account',
            label: i18n.t('account'),
            readonly: true,
            disabled: true
        },
        {
            type: 'select',
            name: 'account_action',
            label: i18n.t('action'),
            placeholder: i18n.t('please_select'),
            options: actionSelects.value
        },
        {
            type: 'number',
            name: 'amount',
            label: i18n.t('amount'),
            fund: true,
        },
        {
            type: 'text',
            name: 'remark',
            label: i18n.t('remark'),
        }
    ]
});

onMounted(async () => {
    model.value.account = i18n.t(`${String(props.account).toLowerCase()}_account`);
    await nextTick(() => {
        pageReady.value = true;
    });
});
const submitForm = async () => {
    try {
        await form.value.submitForm('/account/submit_adjust');

        emit('close');
    } catch (e) {
        console.log(e);
    }
}
</script>
